// Code generated by mockery v2.42.3. DO NOT EDIT.

package mocks

import mock "github.com/stretchr/testify/mock"

// MockDecoder is an autogenerated mock type for the Decoder type
type MockDecoder struct {
	mock.Mock
}

type MockDecoder_Expecter struct {
	mock *mock.Mock
}

func (_m *MockDecoder) EXPECT() *MockDecoder_Expecter {
	return &MockDecoder_Expecter{mock: &_m.Mock}
}

// Decode provides a mock function with given fields: b, v
func (_m *MockDecoder) Decode(b []byte, v interface{}) error {
	ret := _m.Called(b, v)

	if len(ret) == 0 {
		panic("no return value specified for Decode")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func([]byte, interface{}) error); ok {
		r0 = rf(b, v)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockDecoder_Decode_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Decode'
type MockDecoder_Decode_Call struct {
	*mock.Call
}

// Decode is a helper method to define mock.On call
//   - b []byte
//   - v interface{}
func (_e *MockDecoder_Expecter) Decode(b interface{}, v interface{}) *MockDecoder_Decode_Call {
	return &MockDecoder_Decode_Call{Call: _e.mock.On("Decode", b, v)}
}

func (_c *MockDecoder_Decode_Call) Run(run func(b []byte, v interface{})) *MockDecoder_Decode_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].([]byte), args[1].(interface{}))
	})
	return _c
}

func (_c *MockDecoder_Decode_Call) Return(_a0 error) *MockDecoder_Decode_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockDecoder_Decode_Call) RunAndReturn(run func([]byte, interface{}) error) *MockDecoder_Decode_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockDecoder creates a new instance of MockDecoder. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockDecoder(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockDecoder {
	mock := &MockDecoder{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
